--geiles game by knorke
---vielleicht bei setdata nicht auf den lokalen temp. blayer/rock w/e verweisen sondern auf den tatschlichen neuen eintrag
local sin = math.sin
local cos = math.cos
local random = math.random
local global_dt
local menu_ship_a = 0
--ship parameters--
local ship_radius = 10
local ship_acc = 500
local ship_turnrate = 5
local ship_max_energy = 100
local ship_energy_per_shot = 25
local ship_energy_recharge = 50
local shield_max_power = 100
local shield_drain = 40
local ship_firerate = 500
--bullet parameters--
local bullet_speed = 100
local bullet_min_speed = 5000
local bullet_radius = 4
--rock parameters--
local rock_speed = 1
local large_rock_radius = 60
local medium_rock_radius = 30
local small_rock_radius = 15

local console ="nix" --als table und so blabla
local update_timer = 0 	 --increased in update(dt) by +dt
local time_to_update = 0.0 --if update_timer > time_to_update then update the physic, particles etc
local update_skip_count = 0 --how often updating was skipped until update_timer was big enough

local level = 0
local res_w = 800
local res_h = 600
local show_debug = false
local play_sounds = false
  
local bullets = {}
local rocks = {}
local sound_laser = nil
local sound_rockexplode = nil

local players = {} --key_shot  key_left  key_right  key_up  body  shape shield_power  ship_energy  lives  points 
				   --want_shot want_left want_right want_up joystick_nr p.button_left p.button_right p.button_up p.button_shot is_ai is_active

local game_status --MENU INGAME GAMEOVER CONTROLLCONFIG
local game_mode ="A" --"A": level, 3 lives per player  "B": continously spawn new rocks, lose points when ship explodes
mini_font = love.graphics.newFont( 15 )
small_font = love.graphics.newFont( 20 )
large_font = love.graphics.newFont( 30 )
font = love.graphics.newFont( 1.0 )
local ingame_messages = {} --lifetime text

function love.load()
world = love.physics.newWorld(800, 600) --create a world for the bodies to exist in
world:setGravity(0, 0)
world:setMeter(64) --the height of a meter in this world will be 64px
world:setCallbacks(add_collide) --add_collide, add_collide, add_collide)
--	player = love.physics.newBody(world, 100, 100, 10, 5)
--	player:setBullet (true) --I MUST BECOME THE BULLET
add_player ()
add_player ()
add_player ()
add_player ()
love.graphics.setMode(res_w, res_h) --,true for fullscreen
--ship_energy = ship_max_energy
sound_laser = love.audio.newSource("laser.wav", "static")
sound_rockexplode = love.audio.newSource("clonk.wav", "static")
sound_newlevel = love.audio.newSource("achtungachtung.wav", "static")
sound_shipexplode = love.audio.newSource("abkotz.wav", "static")
--data = love.sound.newSoundData("laser.wav")
--sound_laser = love.audio.newSource(data)
game_status = "MENU"
love.graphics.setColor(0, 255, 150, 255)
love.graphics.setLine(3)
--Partikelsystem:
particle_gfx_rock_explosion = love.graphics.newImage("explosion_particle.png");
ps_rock_explosion = love.graphics.newParticleSystem(particle_gfx_rock_explosion, 1000)
ps_rock_explosion:setEmissionRate(100)
ps_rock_explosion:setSpeed(300, 300)
ps_rock_explosion:setGravity(0, 0)
ps_rock_explosion:setSize(1, 1)
ps_rock_explosion:setColor(200, 255, 200, 170,   0, 255, 0, 0)  -- r1, g1, b1, a1, r2, g2, b2, a2 )
ps_rock_explosion:setPosition(400, 300)
ps_rock_explosion:setLifetime(0.1)
ps_rock_explosion:setParticleLife(0.5)
ps_rock_explosion:setDirection(360)
ps_rock_explosion:setSpread(20)
ps_rock_explosion:stop()

particle_gfx_ship_explosion = love.graphics.newImage("explosion_particle_ship.png");
ps_ship_explosion = love.graphics.newParticleSystem(particle_gfx_ship_explosion, 100)
ps_ship_explosion:setEmissionRate(60)
ps_ship_explosion:setSpeed(20, 100)
ps_ship_explosion:setDirection(360)
ps_ship_explosion:setGravity(0, 0)
ps_ship_explosion:setSize(0.4, 0.4)
--ps_ship_explosion:setColor(0, 255, 200, 255,   0, 255, 0, 0)  -- r1, g1, b1, a1, r2, g2, b2, a2 )
ps_ship_explosion:setColor(255, 255, 200, 255,   0, 0, 0, 0)  -- r1, g1, b1, a1, r2, g2, b2, a2 )
ps_ship_explosion:setPosition(400, 300)
ps_ship_explosion:setLifetime(0.1)
ps_ship_explosion:setParticleLife(3)
ps_ship_explosion:setSpin(-10, 10)
ps_ship_explosion:setSpread(20)
ps_ship_explosion:stop()

particle_gfx_ship_exhaust = love.graphics.newImage("exhaust_particle.png");
ps_ship_exhaust = love.graphics.newParticleSystem(particle_gfx_ship_exhaust, 1000)
ps_ship_exhaust:setEmissionRate(20)
ps_ship_exhaust:setSpeed(150, 200)
ps_ship_exhaust:setDirection(360)
ps_ship_exhaust:setGravity(0, 0)
ps_ship_exhaust:setSize(0.4, 0.4)
ps_ship_exhaust:setColor(200, 255, 100, 220,   0, 150, 0, 200)  -- r1, g1, b1, a1, r2, g2, b2, a2 )
ps_ship_exhaust:setPosition(400, 300)
ps_ship_exhaust:setLifetime(0.1)
ps_ship_exhaust:setParticleLife(0.5)
ps_ship_exhaust:setSpin(-10, 10)
ps_ship_exhaust:setSpread(.3)
ps_ship_exhaust:stop()
end


function new_game ()
for i,p in ipairs(players) do
	p.b:setPosition (res_w/2,res_h/2)
	p.b:setLinearVelocity (0,0)
	p.b:setAngle (0)
	p.points = 0
	p.lives = 3
	p.shield_power = shield_max_power	
	p.playstatus = "RESPAWN" --eigentlich INGAME und dann nur die spieler verwenden die im menu gesetzt sind***
	end
rocks = {}
bullets = {}
shield_power = shield_max_power --the power is maximum!
game_status = "INGAME"
players[1].playstatus = "INGAME" --spieler eins immer ingame***
level = 1
new_level()
if (game_mode == "B") then add_ingame_message ("Get 1000 Points to win!") end
end

function new_ship (pres)
pres.b:setPosition (res_w/2,res_h/2)
pres.b:setLinearVelocity (0,0)
pres.b:setAngle (0)
pres.is_active = true
--lives = lives -1
pres.status="SHIP"
pres.shield_power = shield_max_power
pres.ship_energy = ship_max_energy
pres.playstatus = "INGAME"
pres.gun_blocktime = 0
end

function love.draw()
love.graphics.setColorMode("modulate")
love.graphics.setBlendMode("alpha")
if (game_status == "MENU" or game_status == "GAMEOVER") then draw_menu () end
	if (show_debug == true) then
		love.graphics.setColor(255, 0, 255, 255)
		font:setLineHeight (1.0)
		love.graphics.setFont( mini_font )
		love.graphics.print("#bullets:" .. #bullets, 200, 200)
		love.graphics.print("#rocks:" .. #rocks, 200, 210)		
		love.graphics.print("game_status:" .. game_status, 10, 50)	
		love.graphics.print("level:" ..level, 10, 60)
		love.graphics.print("press F10 to toggle this debug info", 10, 70)
		love.graphics.print("#players:" .. #players, 10, 80)
		love.graphics.print("Melder:" .. console, 10, 100)
		love.graphics.print("world:getbodyCount:" .. world:getBodyCount(), 300, 100)
		love.graphics.print("update_timer" .. update_timer, 10, 110)
		for i,p in ipairs(players) do
			love.graphics.print(p.gun_blocktime,  p.b:getX(), p.b:getY()+ship_radius*2)
			love.graphics.print("playstatus=" .. p.playstatus .. " energy=" .. math.floor(p.ship_energy) .. " shield" .. math.floor(p.shield_power) .. "Pos:" .. math.floor(p.b:getX()) .. ":" 
			.. math.floor(p.b:getY()) .. "gun_blocktime:" .. p.gun_blocktime,  50, 120+i*12)
			end
		end

if (game_status == "INGAME" or game_status =="RESPAWN" ) then draw_ingame () end

love.graphics.setBlendMode("additive")
love.graphics.draw(ps_ship_explosion, 0, 0)
love.graphics.draw(ps_rock_explosion, 0, 0)
love.graphics.draw(ps_ship_exhaust, 0, 0)
end

function draw_ingame ()
love.graphics.setColor(0, 255, 150, 255)		
draw_bullets ()
draw_rocks ()
show_ingame_messages ()
--draw players--
	love.graphics.setFont(large_font)
	if (game_status == "INGAME") then 
	for i,p in ipairs(players) do
			if (p.is_active == true) then
			set_player_color (i)		
	--		if (p.playstatus == "INGAME") then draw_ship (p.b:getX(), p.b:getY(), p.player_a, p.shield_power) end
			draw_ship (p.b:getX(), p.b:getY(), p.b:getAngle(), p.shield_power)
			local dx = ((i-1) * 200)
			local dy = res_h-30			
			love.graphics.print("Score:"..p.points, dx, dy)
			--live display
			if (game_mode == "A") then
				if (p.lives > 0) then
					for bla = 1, p.lives, 1 do
						draw_ship (dx+bla*ship_radius*1.8, dy+20,0)
						end
					end
				end
			end
		end
	end
end

function add_collide (a, b, coll)
local cx, cy = coll:getPosition( )
--ps_rock_explosion:setPosition(cx,cy)
--ps_rock_explosion:start()
if (a == nil or b == nil) then return end
local a_status
local b_status
a_status = a.status
b_status = b.status
console = a.status .. " " .. b.status
if (a_status == b_status) then return end
--ship vs bullet - bullet explodes
--if (a_status == "SHIP" and b_status == "BULLET") then return end
--if (a_status == "BULLET" and b_status == "SHIP") then return end
-- rock vs bullet - both explodieren
if (a_status == "BULLET" and b_status == "ROCK") then a_status = "HIT" b_status = "HIT" b.destroyed_by = a.owner end
if (a_status == "ROCK" and b_status == "BULLET") then a_status = "HIT" b_status = "HIT" a.destroyed_by = b.owner end
--rock vs ship - ship explodes
if (a_status == "ROCK" and b_status == "SHIP") then if (b.shield_power < 1) then b_status = "HIT" end end
if (a_status == "SHIP" and b_status == "ROCK") then if (a.shield_power < 1) then a_status = "HIT" end end
a.status = a_status
b.status = b_status
collision()
end



function collision()
--players
for i,p in ipairs(players) do
	--screen edges
	if (p.b:getX() < -ship_radius/2) then p.b:setX (res_w+ship_radius/2) end
	if (p.b:getX() > res_w+ship_radius/2) then p.b:setX (-ship_radius/2) end
	if (p.b:getY() < -ship_radius/2) then p.b:setY (res_h+ship_radius/2) end
	if (p.b:getY() > res_h+ship_radius/2) then p.b:setY (-ship_radius/2) end
	if (p.playstatus == "RESPAWN" or p.playstatus == "DEAD") then
		p.b:setX(-666) p.b:setY(-666) --so no rocks hit the hidden dead ship
		p.b:setLinearVelocity (0,0)
		end
	if (p.playstatus == "INGAME" and p.status == "HIT" and p.shield_power < 1) then
			ps_ship_explosion: setPosition(p.b:getX(),p.b:getY())
			ps_ship_explosion:start()
			p.b:setX(-666) p.b:setY(-666) --so no rocks hit the hidden dead ships
			p.b:setLinearVelocity (0,0)
			p.status = "SHIP"
			if (game_mode == "A") then
				if (p.lives > 0) then p.lives = p.lives - 1 p.playstatus = "RESPAWN" else p.playstatus = "DEAD" end
				end
			if (game_mode == "B") then
				p.points = math.floor (p.points / 2)  p.playstatus = "RESPAWN"
				if (p.points < 0) then p.points = 0 end
				end
			play_sound (sound_shipexplode)			
		end
	end

--rocks
local rock_delete_count = 0
for u,r in ipairs(rocks) do	
	local rx = r.b:getX()
	local ry = r.b:getY()
	local rr = r.s:getRadius()		
	if (rx < -rr) then rx = res_w+rr end
	if (rx > res_w+rr) then rx = -rr end
	if (ry < -rr) then ry = res_h+rr end
	if (ry > res_h+rr) then ry = -rr end
	r.b:setPosition (rx,ry)
	if (r.status == "HIT") then
		if (r.destroyed_by.points~=nil) then r.destroyed_by.points = r.destroyed_by.points + r.size*15 end				
		local new_size = r.size - 1
		local nrx,nry = r.b:getX(), r.b:getY()	
		r.status = "DELETE"
		rock_delete_count = rock_delete_count + 1
		--		table.remove (rocks, u)
		if (new_size == 1) then
			add_rock (1, nrx, nry)
			add_rock (1, nrx,nry)
			end
		if (new_size == 2) then
			add_rock (2, nrx,nry)
			add_rock (2, nrx,nry)
			end
		--table.insert (rocks_to_delete, u)
		--table.remove(bullets, i)
		ps_rock_explosion: setPosition(rx,ry)  --**** die beiden zeilen sind natrlich richtig und die -- nur zum testen
		ps_rock_explosion:start()				--****
		play_sound(sound_rockexplode)		
		end
	end
	
	---lsch schleife rocks------
for i = #rocks, 1, -1 do
	if (rocks[i].status ~="ROCK") then
	rocks[i].b:setX(-555) rocks[i].b:setY(-555) --get the fuck away from me
	rocks[i].b:setLinearVelocity (0,0)	
	table.remove(rocks, i)
		end
end		

	--[[
for bla = 1, rock_delete_count, 1 do
	for u,r in ipairs(rocks) do	
	if (r.status == "DELETE") then 
	r.b:setX(-555) r.b:setY(-555) --get the fuck away from me
	r.b:setLinearVelocity (0,0)	
	table.remove (rocks, u) 
		rock_delete_count = rock_delete_count - 1 
		break 
		end
	end
	end	]]
	--------------
	--table.remove (rocks, rocks_to_delete)
--bullets
local bullet_delete_count = 0
	for i,v in ipairs(bullets) do
--		if (is_offscreen (v.b:getX(), v.b:getY()) == true) then table.remove(bullets, i) end --remove bullets outside of screen	
		--if (v.status=="HIT") then table.remove(bullets, i) end --remove bullets that hit things	
		local xs, ys = v.b:getLinearVelocity()		
		if ((xs*xs) + (ys*ys) < bullet_min_speed or v.status=="HIT" or is_offscreen (v.b:getX(), v.b:getY()) == true) then 
		bullet_delete_count = bullet_delete_count +1
		v.status = "DELETE"
		end
		end

for i = #bullets, 1, -1 do
	if (bullets[i].status =="DELETE") then
	bullets[i].b:setX(-555) bullets[i].b:setY(-555) --get the fuck away from me
	bullets[i].b:setLinearVelocity (0,0)	
		 table.remove(bullets, i)
		end
end		


		---lsch schleife bullets----
--[[
	for bla = 1, bullet_delete_count, 1 do
	for i,v in ipairs(bullets) do	
		if (v.status == "DELETE") then 
			v.b:setX(-555) v.b:setY(-555) --get the fuck away from me
			v.b:setLinearVelocity (0,0)				
			--v.b:destroy()
--			v.s = nil
			table.remove (bullets, i) 
			bullet_delete_count = bullet_delete_count - 1 
			break 
			end
		end
	end	-]]
	--------------
end


function is_offscreen (x,y)
if (x < 0) then return true end
if (y < 0) then return true end 
if (x > res_w) then return true end 
if (y > res_h) then return true end
return false
end

function is_far_offscreen (x,y)
if (x < -res_w/2) then return true end
if (y < -res/2) then return true end
if (x > res_w*1.5) then return true end
if (y > res_h*1.5) then return true end
return false
end



function love.update(dt)
global_dt = dt --wer brauchts?
menu_ship_a = menu_ship_a+ship_turnrate*dt
--------------------------------------------------------------------
----------------------------   INGAME   ----------------------------
--------------------------------------------------------------------
if (game_status == "INGAME") then 
	timeout_ingame_messages (dt)
	for i,p in ipairs(players) do
		if (p.playstatus == "INGAME") then
		if (p.is_ai == true) then 
		local ai_l, ai_r, ai_u, ai_s = ship_ai (p)
		p.want_left = ai_l
		p.want_right = ai_r
		p.want_up = ai_u
		p.want_shot = ai_s
		end
		
		if (p.joystick_nr == nil) then
			----keyboard controlls -----
			if love.keyboard.isDown(p.key_left) then p.want_left = true end
			if love.keyboard.isDown(p.key_right) then p.want_right = true end
			if love.keyboard.isDown(p.key_up) then p.want_up = true end
			if love.keyboard.isDown(p.key_shot) and p.gun_blocktime < 1 then p.want_shot = true end
		else
			if (love.joystick.isDown(p.joystick_nr , p.button_left )) then p.want_left=true end
			if (love.joystick.isDown(p.joystick_nr , p.button_right )) then p.want_right=true end
			if (love.joystick.isDown(p.joystick_nr , p.button_up )) then p.want_up=true end
			if (love.joystick.isDown(p.joystick_nr , p.button_shot)) then p.want_shot=true end
		end
		
		----ship movement physik----
		local old_a = p.b:getAngle()
		p.b:setAngularVelocity (0)
		if (p.want_left)  then p.b:setAngle (old_a + (ship_turnrate*dt)) p.want_left = false end
		if (p.want_right) then p.b:setAngle (old_a - (ship_turnrate*dt)) p.want_right = false end
		--***obs was bringt? ist bldsinn
		--if (p.b:getAngle() >  math.pi*2) then p.b:setAngle(math.pi*2-p.b:getAngle() ) end
		--if (p.b:getAngle() <  0) then p.b:setAngle(math.pi*2-p.b:getAngle() ) end
		
		if (p.want_up) then 
			local thrust_fx = -sin(p.b:getAngle()) *  ship_acc
			local thrust_fy = -cos(p.b:getAngle()) *  ship_acc
			p.b:applyForce (thrust_fx, thrust_fy)
			ps_ship_exhaust:setPosition (p.b:getX()+ sin(p.b:getAngle())*ship_radius/2, p.b:getY()+cos(p.b:getAngle())*ship_radius/2)
			ps_ship_exhaust:setDirection(-p.b:getAngle()+(3.14/2))
			ps_ship_exhaust:start()					
			p.want_up = false
			end
		----- ship shoots -----
		if (p.want_shot == true and p.ship_energy > ship_energy_per_shot and p.shield_power < 1 and p.gun_blocktime < 1) then
				p.gun_blocktime = 100
				shoot_bullet (p.b:getX()  -sin(p.b:getAngle()) *ship_radius*1.5, p.b:getY()-cos(p.b:getAngle()) *ship_radius*1.5, p.b:getAngle(), p)
				p.ship_energy = p.ship_energy - ship_energy_per_shot
				p.want_shot = false
				end
		p.want_shot = false
		end
		---- stuff recharges ----
		if (p.ship_energy < ship_max_energy) then p.ship_energy = p.ship_energy + ship_energy_recharge * dt end  --energy recharges over time
		if (p.shield_power > 0) then p.shield_power = p.shield_power - shield_drain * dt end					--shield power goes down over time			
		if (p.gun_blocktime > 0) then p.gun_blocktime = p.gun_blocktime - ship_firerate *dt end
		end	
	if (game_mode == "A" and #rocks == 0) then new_level () end
	if (game_mode == "B" and #rocks < 3) then add_rock (3,nil ,nil) end	
	end
	
--jostick controlls
if (love.joystick.isDown(2 , 1 )) then players[1].want_left=true end
if (love.joystick.isDown(2 , 2 )) then players[1].want_right=true end
if (love.joystick.isDown(2 , 3 )) then players[1].want_up=true end
if (love.joystick.isDown(2 , 4)) then players[1].want_shot=true end
	
	update_timer = update_timer + dt
--console = update_skip_count
if (update_timer > time_to_update) then
	world:update(update_timer)
	collision ()
	ps_rock_explosion:update(update_timer)
	ps_ship_explosion:update(update_timer)
	ps_ship_exhaust:update(update_timer)
	update_timer = 0
	update_skip_count = 0
	end
update_skip_count = update_skip_count +1

----end game conditions----
if (game_mode == "B") then
		for i,p in ipairs(players) do
		if (p.points > 1000) then game_status = "GAMEOVER" end
		end
	end
local players_ingame = 0
if (game_mode == "A") then
	for i,p in ipairs(players) do
		if (p.lives > 0 and p.is_active==true) then players_ingame = players_ingame + 1 end
		end
	if (players_ingame == 0) then game_status = "GAMEOVER" end
	end
end

function love.keypressed(key, unicode)
if (key=="f2") then
players[1].points = 550
players[2].points = 50
players[3].points = 620
players[4].points = 380
end
if (key=="f9") then new_level () end
if (key=="f12") then game_status = "GAMEOVER" end
if (key=="f10") then
	if (show_debug==true) then show_debug = false else show_debug = true end
	end
--if (key=='a') then add_rock (3) end
if (game_status=="INGAME") then
	for i,p in ipairs(players) do		
			--[[das ist jetzt in love.update mit gun_blocktime
			if (p.playstatus == "INGAME" and key == p.key_shot and p.ship_energy > ship_energy_per_shot and p.shield_power < 1) then
				shoot_bullet (p.b:getX()  -sin(p.player_a) *ship_radius*1.5, p.b:getY()-cos(p.player_a) *ship_radius*1.5, p.player_a, p)
				p.ship_energy = p.ship_energy - ship_energy_per_shot
				end				
				--]]
		if (key == p.key_shot and p.playstatus == "RESPAWN" and p.lives > 0) then new_ship (p) end
		end
	end
if (key == "n" and (game_status == "MENU" or game_status=="GAMEOVER")) then  new_game () end

if (key == "c" and (game_status == "MENU" or game_status=="GAMEOVER")) then  game_status = "CONTROLLCONFIG" end
if (key == "escape" and (game_status == "MENU" or game_status =="GAMEOVER")) then love.event.push("q") end
if (key == "escape" and (game_status == "INGAME" or game_status == "RESPAWN")) then game_status = "MENU" end
if (key == "g" and (game_status == "MENU" or game_status=="GAMEOVER")) then  
	if (game_mode == "A") then game_mode ="B" return end
	if (game_mode == "B") then game_mode ="A" return end
	end
if (key == "f1") then 
	if (play_sounds == true) then play_sounds = false return end
	if (play_sounds == false) then play_sounds = true return end
	end	
end


function shoot_bullet (gunx, guny, guna, bullet_owner)
--local gunx,gun_y,guna
if (gunx==nil or guny==nil or guna==nil) then
--	gunx = player:getX()
--	guny = player:getY()
--	guna = player_a
	gunx = 100
	guny= 100
	guna = 1	
	end
play_sound(sound_laser)
local newbullet = {}
newbullet.b = love.physics.newBody(world, gunx, guny,10,5)
newbullet.s = love.physics.newCircleShape(newbullet.b, bullet_radius)
newbullet.status = "BULLET"
newbullet.owner = bullet_owner
newbullet.s:setRestitution (1)
newbullet.s:setData (newbullet)
newbullet.b:setBullet (true)
newbullet.b:applyImpulse (-sin(guna) *  bullet_speed, -cos(guna) *  bullet_speed)
table.insert(bullets, newbullet)
--newbullet.b:destroy()
--newbullet.s:destroy()
newbullet = nil
end   

function draw_ship (x,y, a, shield)
--love.graphics.setColor(0, 255, 150, 255)
--love.graphics.setColor(255, 255, 50, 255)
love.graphics.setLine(3)
local p1x = (x-sin(a)*ship_radius) -- obere Spitze
local p1y=(y-cos(a)*ship_radius)
   local p2x= (x+sin(a)*ship_radius/2)--unteres Ende
   local p2y=(y+cos(a)*ship_radius/2)
local p3x= (x+sin(a-0.8)*ship_radius)--- linke Flgelspitze
local p3y= (y+cos(a-0.8)*ship_radius)
   local p4x= (x+sin(a+0.8)*ship_radius)-- rechte Flgelspitze
   local p4y= (y+cos(a+0.8)*ship_radius)
love.graphics.line (p1x,p1y, p4x,p4y)
love.graphics.line (p1x,p1y, p3x,p3y)
love.graphics.line (p4x,p4y, p2x,p2y)
love.graphics.line (p3x,p3y, p2x,p2y)
 if (shield ~= nil) then
	if (shield > 1) then 
	love.graphics.circle ("line",x,y, ship_radius*2,16)
	end	
	end
if (show_debug==true) then
	love.graphics.setColor(255, 0, 255, 255)
	love.graphics.circle ("line",x,y, ship_radius,20)	
	end
 end
 
 function draw_bullets ()
 love.graphics.setColor(0, 255, 150, 255)
 for i,v in ipairs(bullets) do
	love.graphics.circle ("line", v.b:getX(), v.b:getY(), bullet_radius, 8)
	end
 end

 
function add_rock (size, x,y)
if (x==nil) then x = random (0, res_w) end
if (y==nil) then y = random (-500, -200) end
local newrock = {}
local nr = small_rock_radius
if (size == 3) then nr = large_rock_radius end
if (size == 2) then nr = medium_rock_radius end
if (size == 1) then nr = small_rock_radius end

newrock.b = love.physics.newBody(world, x, y, nr*100,5)
newrock.s = love.physics.newCircleShape(newrock.b, nr)
newrock.status = "ROCK"
newrock.size = size
newrock.destroyed_by = nil
newrock.s:setRestitution (0.95)
newrock.s:setData (newrock)
if (size == 1) then newrock.b:applyImpulse (random (-9000,9000), random (-9000,9000))
else newrock.b:applyImpulse (random (-5000,5000), random (-5000,5000))
end

table.insert(rocks, newrock)
--newrock.b:destroy()
--newrock.s:destroy()
newrock = nil
end


function new_level ()
rocks = {}
if (level == 1) then add_rock (3) end
if (level == 2) then 
	add_rock (3)
	add_rock (2)
	end
if (level == 3) then 
	add_rock (3)
	add_rock (2)
	add_rock (1) 
	end	
if (level > 3) then
	for blabla = 0, level*2, 1 do
		add_rock (math.random(1,3))
		end
	end
shield_power = shield_max_power
if (game_mode=="A") then add_ingame_message ("Level " .. level .. " Get Ready!") end
level = level + 1
play_sound(sound_newlevel)
end

 
function draw_rocks ()

love.graphics.setColor(0, 255, 150, 255)
for i,v in ipairs(rocks) do
	love.graphics.circle ("line", v.b:getX(), v.b:getY(), v.s:getRadius(), 32)
	if (show_debug==true) then
		font:setLineHeight (1.0)
		love.graphics.print(math.floor(v.b:getX())..":".. math.floor(v.b:getY()) , v.b:getX(), v.b:getY()) 
	end
	end
 end
 
--***tasten zuweisen aus local buttons = {} oder so 
function add_player ()
if (#players > 3) then return end
local new_player = {}
new_player.playstatus = "RESPAWN" --INGAME, RESPAWN, DEAD
new_player.is_ai = false
new_player.is_active = false
if (#players == 0) then
	new_player.key_shot ="down"
	new_player.key_left ="left"
	new_player.key_right ="right"
	new_player.key_up ="up"
	new_player.jstick = love.joystick.open( 2 )
	new_player.playstatus = "INGAME"
	new_player.is_active = true
	--new_player.is_ai = true
	end
if (#players == 1) then
	new_player.key_shot ="s"
	new_player.key_left ="a"
	new_player.key_right ="d"
	new_player.key_up ="w"
	end
if (#players == 2) then
	new_player.key_shot ="kp5"
	new_player.key_left ="kp4"
	new_player.key_right ="kp6"
	new_player.key_up ="kp8"
	end
if (#players == 3) then
	new_player.key_shot ="j"
	new_player.key_left ="h"
	new_player.key_right ="k"
	new_player.key_up ="u"
	end	
new_player.joystick_nr = nil
new_player.gun_blocktime = 0
new_player.shield_power = shield_max_power
new_player.ship_energy = ship_max_energy
new_player.lives = 3
new_player.points = 0
new_player.status = "SHIP"
new_player.b = love.physics.newBody(world, math.random(100,200), math.random(100,200), 100, 5)
--new_player.b:setBullet (true) --I MUST BECOME THE BULLET
new_player.s = love.physics.newCircleShape(new_player.b, ship_radius)
new_player.s:setRestitution (0.2)
new_player.s:setData (new_player)
new_player.want_left = false
new_player.want_right = false
new_player.want_shot = false
new_player.want_up = false
new_player.b:setAngle(0)
table.insert(players, new_player)
 new_player.n = nil
 --local newplayers = {} --key_shot key_left key_right key_up body shape player_a shield_power ship_energy lives
 end
 
function play_sound (sfx)
 if (play_sounds == true) then
	love.audio.stop(sfx)
	love.audio.play(sfx)
	end
 end
 
 --love.graphics.printf( text, x, y, limit, align )
function draw_menu ()
love.graphics.setColor(0, 255, 0, 255)
love.graphics.setFont( large_font )
love.graphics.print("Astropatrolonium!", res_w/2+random(0,5)-200, res_h/4+random(0,5))
love.graphics.setFont( small_font )
love.graphics.print("press n for a new game.", res_w/2-300, res_h/4+100)
--love.graphics.print("press + to add player. press - to remove a player", res_w/2-300, res_h/4+70)
local gamemode_displayname
if (game_mode=="A") then gamemode_displayname = "Levels" end
if (game_mode=="B") then gamemode_displayname = "No Ending" end
love.graphics.print("game mode: ".. gamemode_displayname .. " (press g to change)" , res_w/2-300, res_h/4+85)
local sound_s = "off"
if (play_sounds==true) then sound_s = "on" end
love.graphics.print("sound is " .. sound_s .. " (press F1 to change)", res_w/2-300, res_h-20)
local xs = 200
local ys = 350
for i,v in ipairs(players) do
	set_player_color (i)
	draw_ship (xs,ys,menu_ship_a+0.2*i)
	local player_s ="->"
	player_s = "turn: " .. players[i].key_left.." & "..players[i].key_right .. "  thrust:" .. players[i].key_up .. "  shot:" ..players[i].key_shot
	if (game_status == "GAMEOVER") then player_s = player_s .. " Score:" .. players[i].points end
	--if (players[i] ~= nil) then button_s = love.joystick.getName(2) end
	love.graphics.print(player_s, xs+20,ys+10)
	ys=ys+50
	end
--show_status_of_all_joystick ()
end

function set_player_color (playernumber)
if (playernumber==1) then love.graphics.setColor(0, 255, 150, 255) end
if (playernumber==2) then love.graphics.setColor(0, 155, 255, 255) end
if (playernumber==3) then love.graphics.setColor(255, 255, 0, 255) end
if (playernumber==4) then love.graphics.setColor(255, 255, 255, 255) end
end

function show_status_of_all_joystick ()
love.graphics.setFont( small_font )
love.graphics.setColor(255, 0, 0, 255)
local dx=100
local dy = res_h/2
local buttons_down_s = "LOL"
local button_n = 666
love.graphics.print(love.joystick.getNumJoysticks(), dx-30, dy)
for j = 0, love.joystick.getNumJoysticks(), 1 do
	love.joystick.open( j )
	if (love.joystick.isOpen(j) == true) then
		button_n = love.joystick.getNumButtons(j)
		buttons_down_s = "pressed buttons:"
			for b = 0, button_n, 1 do
			if (love.joystick.isDown(j , b )) then buttons_down_s = buttons_down_s .. tostring (b) .. "," end			
			end
		love.graphics.print("->" ..  love.joystick.getName(j), dx, dy)
		love.graphics.print("=> buttons:" .. button_n .. " " .. buttons_down_s, dx, dy+20)
		dy=dy+45
		end
		end
end




function distance (x1,y1 ,x2,y2)
local xdiff = x1 - x2
local ydiff = y1 - y2
local summer = xdiff * xdiff + ydiff * ydiff
return math.sqrt(summer)
end

function ship_ai (player)
local want_left, want_right, want_up, want_shot = false
local shipx, shipy = player.b:getPosition( )
local xs, ys = player.b:getLinearVelocity ()
local current_a = (player.b:getAngle())
--
 for i,v in ipairs(rocks) do
	if (distance (shipx, shipy,  v.b:getX(), v.b:getY()) < 200) then want_shot = true end	
	end

drifting_a = math.atan2(xs, ys) --math.atan2(1,0)  --richtung in die das raumschiff gerade abdriftet, NICHT drehrichtung
local diff_a =  drifting_a-current_a
console = diff_a

if (distance (xs,ys, 0,0) < 150) then
if (diff_a >  0.1) then want_left = true end
if (diff_a < - 0.1) then want_right = true end
if (math.random (0,100) < 50) then want_up=true end
end

if (distance (xs,ys, 0,0) > 150)   then  --fliegt zu schnell?
	--gegen flugrichtung drehen
	if (diff_a <  0.1) then want_right = true end
	if (diff_a > - 0.1) then want_left = true end	
	if (math.abs (diff_a) < 0.1) then want_up = true end
	end
if (distance (xs,ys, 0,0) < 50)   then
	
	end
		--math.atan2(a.y, a.x)-math.atan2(b.y,b.x)

return want_left, want_right, want_up, want_shot
end


function add_ingame_message (text)
local new_msg = {}
new_msg.text = text
new_msg.lifetime = 3
table.insert (ingame_messages, new_msg)
end

function show_ingame_messages ()
for i,m in ipairs(ingame_messages) do
		if (m.lifetime > 0) then
			love.graphics.setColor(255, 255, 255, 255)
			font:setLineHeight (1.0)
			love.graphics.setFont(large_font)
			love.graphics.print(m.text, 250, 400-m.lifetime*100)
			end
	end
end

function timeout_ingame_messages (dt)
for i,m in ipairs(ingame_messages) do
	m.lifetime=m.lifetime-dt
	end
end

--[[  man das ist halt alt
--player controlls keyboard				
			if love.keyboard.isDown(p.key_left) then p.player_a=p.player_a+(ship_turnrate*dt) end
			if love.keyboard.isDown(p.key_right) then p.player_a=p.player_a-(ship_turnrate*dt) end
				if love.keyboard.isDown(p.key_up) then 
					local thrust_fx = -sin(p.player_a) *  ship_acc
					local thrust_fy = -cos(p.player_a) *  ship_acc
					p.b:applyForce (thrust_fx, thrust_fy)
					ps_ship_exhaust:setPosition (p.b:getX()+ sin(p.player_a)*ship_radius/2, p.b:getY()+cos(p.player_a)*ship_radius/2)
					ps_ship_exhaust:setDirection(-p.player_a+(3.14/2))
					ps_ship_exhaust:start()					
					end			
]]